# 问题

## 1.图像识别和OCR识别服务可否本地部署

可以，本地部署方法 🚧

## 2. 图像识别和OCR识别为什么不基于 Nginx 做负载均衡

### 问题描述

以下以 OCR 业务说明：

1. 每次 `OCR` 识别业务实际是两次 `RPC` 接口请求，第 1 次是将当前屏幕截图并发送到 `PRC` 服务器，第 2 次调用识别的接口做识别，采用 Nginx 轮询算法做负载均衡会出现两次 `RPC` 请求被分发到两台不同的服务器上，这明显是错误的。
2. 基于 Nginx  `ip_hash` 的 `session` 管理负载均衡算法时，Nginx 默认取 IP 的前 3 段做哈希，而我们的测试机都在同一个网段，IP 前 3 段是一样的，因此会导致负载不均衡。

### 解决方案

为了解决上面 2 个问题，对  OCR 功能进行了增强，实现了一个中间件用以在用例跑测过程中对 OCR 服务集群进行负载均衡。

![](/ocr/ocr.png)